var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { jsx as _jsx } from "react/jsx-runtime";
import { useEffect, useMemo, useRef } from 'react';
import { useAsyncEffect, useLatest, usePromise, useScheduledEffect, useSharedPromise, useStorage } from '@reactit/hooks';
import { coerceExpiration, isTokenBundleValid } from './token';
import { _AuthContext } from './context';
/**
 * Authentication provider to wrap the entire application. This
 * component does contain all the behavioural logic for the entire
 * authentication workflow.
 *
 * todo : force renew on mount
 */
export function AuthProvider(_a) {
    var _this = this;
    var _b, _c, _d, _e;
    var _f = _a.authStorage, authStorage = _f === void 0 ? 'sessionStorage' : _f, _g = _a.authPrefix, authPrefix = _g === void 0 ? 'auth_' : _g, devToken = _a.devToken, _h = _a.devSignedIn, devSignedIn = _h === void 0 ? false : _h, devUser = _a.devUser, doSignIn = _a.doSignIn, doRenew = _a.doRenew, doSignOut = _a.doSignOut, onTokenChange = _a.onTokenChange, _j = _a.renewOnMount, renewOnMount = _j === void 0 ? false : _j, children = _a.children;
    var _k = useStorage(devSignedIn && devToken ? { initialized: true, auth: { token: devToken } } : { initialized: false }, (devToken ? '$dev_' : '') + authPrefix, authStorage), state = _k[0], setState = _k[1];
    var isFirst = useRef(true);
    // Remove invalid tokens when they expire
    useAsyncEffect(function () { return __awaiter(_this, void 0, void 0, function () {
        var authInv, renewInv, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    authInv = state.auth && !isTokenBundleValid(state.auth);
                    renewInv = state.renew && !isTokenBundleValid(state.renew);
                    if (!((isFirst.current && renewOnMount) || !state.auth || authInv)) return [3 /*break*/, 4];
                    isFirst.current = false;
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, renewTokenAsync(undefined)];
                case 2:
                    _a.sent();
                    return [2 /*return*/];
                case 3:
                    e_1 = _a.sent();
                    return [3 /*break*/, 4];
                case 4:
                    if (authInv || renewInv) {
                        setState(__assign(__assign({}, state), { initialized: true, auth: authInv ? undefined : state.auth, renew: renewInv ? undefined : state.renew }));
                    }
                    return [2 /*return*/];
            }
        });
    }); }, [state]);
    // Autonomous expiration of auth token
    var taskSchedulePromise = usePromise(function () { return __awaiter(_this, void 0, void 0, function () {
        var e_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, renewTokenAsync(undefined)];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    e_2 = _a.sent();
                    setState(__assign(__assign({}, state), { auth: undefined }));
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    useScheduledEffect(taskSchedulePromise, (_b = state.auth) === null || _b === void 0 ? void 0 : _b.expiresAt);
    // Autonomous expiration of renew token
    useScheduledEffect(function () {
        setState(__assign(__assign({}, state), { renew: undefined }));
    }, (_c = state.renew) === null || _c === void 0 ? void 0 : _c.expiresAt);
    // React on token change. On first mount if authenticated the token shall be
    // available immediately, before any subcomponent is rendered, to prevent any
    // initial request from failing.
    var mounted = useRef(false);
    if (onTokenChange && ((_d = state.auth) === null || _d === void 0 ? void 0 : _d.token) && !mounted.current) {
        mounted.current = true;
        onTokenChange(state, state.auth.token);
    }
    useEffect(function () {
        var _a;
        if (!onTokenChange)
            return;
        onTokenChange(state, (_a = state.auth) === null || _a === void 0 ? void 0 : _a.token);
    }, [(_e = state.auth) === null || _e === void 0 ? void 0 : _e.token]);
    // --- Actions ---
    function processExit() {
        setState({ initialized: true });
    }
    function processResult(res) {
        setState(function (_state) { return ({
            initialized: true,
            auth: {
                token: res.token,
                expiresAt: coerceExpiration(res.tokenExpiration)
            },
            renew: res.renew ? {
                token: res.renew,
                expiresAt: coerceExpiration(res.renewExpiration)
            } : _state.renew,
            user: res.user ? res.user : _state.user
        }); });
    }
    /**
     * Just run the standard signIn procedure
     */
    var lastDev = useLatest({ token: devToken, user: devUser });
    var signInAsync = useSharedPromise(function (input) { return __awaiter(_this, void 0, void 0, function () {
        var res, _a;
        var _b, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    // ! Inject dev token if needed
                    if (!((_b = lastDev.current) === null || _b === void 0 ? void 0 : _b.token) && !doSignIn) {
                        throw new Error("AuthProvider has no sign-in function");
                    }
                    if (!((_c = lastDev.current) === null || _c === void 0 ? void 0 : _c.token)) return [3 /*break*/, 1];
                    _a = __assign(__assign({}, lastDev.current), { tokenExpiration: undefined });
                    return [3 /*break*/, 3];
                case 1: return [4 /*yield*/, doSignIn(state, input)];
                case 2:
                    _a = _d.sent();
                    _d.label = 3;
                case 3:
                    res = _a;
                    processResult(res);
                    return [2 /*return*/, res];
            }
        });
    }); });
    /**
     * Call the refresh function and exit in any cas it is not possible
     * to complete the refresh
     */
    var renewTokenAsync = useSharedPromise(function (input) { return __awaiter(_this, void 0, void 0, function () {
        var res;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!doRenew) {
                        throw new Error("AuthProvider has no renew function");
                    }
                    return [4 /*yield*/, doRenew(state, input)];
                case 1:
                    res = _a.sent();
                    processResult(res);
                    return [2 /*return*/, res];
            }
        });
    }); });
    /**
     * Perform a sign-out
     */
    var signOutAsync = useSharedPromise(function (input) { return __awaiter(_this, void 0, void 0, function () {
        var e_3;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!doSignOut) return [3 /*break*/, 4];
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, doSignOut(state, input)];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    e_3 = _a.sent();
                    return [3 /*break*/, 4];
                case 4:
                    processExit();
                    return [2 /*return*/];
            }
        });
    }); });
    var signIn = usePromise(signInAsync);
    var renewToken = usePromise(renewTokenAsync);
    var signOut = usePromise(signOutAsync);
    var ctx = useMemo(function () { return (__assign(__assign({}, state), { signIn: signIn, renewToken: renewToken, signOut: signOut, signInAsync: signInAsync, renewTokenAsync: renewTokenAsync, signOutAsync: signOutAsync, setAuth: processResult })); }, [state]);
    return _jsx(_AuthContext.Provider, { value: ctx, children: children });
}
