export function coerceExpiration(exp) {
    if (typeof exp === 'number') {
        return Date.now() + exp * 1000;
    }
    else if (exp instanceof Date) {
        return exp.getTime();
    }
    else if (exp === undefined) {
        return undefined;
    }
    else {
        throw new Error("Unknown expiration format ".concat(exp));
    }
}
export function isTokenBundleValid(bundle) {
    return !!bundle.token && (!bundle.expiresAt || bundle.expiresAt >= Date.now());
}
